=begin
#Voucherify API

#Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

The version of the OpenAPI document: v2018-08-01
Contact: support@voucherify.io
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 7.0.1

=end

require 'date'
require 'time'

module VoucherifySdk
  # Object representing item replacement.
  class ApplicationDetailsItem
    # Index number of the source item that is replaced. The enumeration starts from `0`, which represents the first item in the request, e.g., if the replaced item is passed as the second in the request, `source_index` equals `3`.
    attr_accessor :source_index

    # Number of source units that are replaced.
    attr_accessor :source_applied_quantity

    # Amount equal to the price of the units that are replaced. Determines the change of the amount of the source item quantity.
    attr_accessor :source_applied_quantity_amount

    # Index number of the target item that is a replacement of the source item. The enumeration continues the values for the order items, e.g. if there are three items in the request, `target_index` equals `3`, as enumeration starts from `0`.
    attr_accessor :target_index

    # Number of added target units that are replacements.
    attr_accessor :target_applied_quantity

    # Amount equal to the price of the units that are replacements. Determines the change in the amount of the target item quantity.
    attr_accessor :target_applied_quantity_amount

    # Discount amount applied to the target item with regard to the replacement. Equals the `target_applied_quantity_amount` minus `source_applied_quantity_amount`.
    attr_accessor :target_applied_discount_amount

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'source_index' => :'source_index',
        :'source_applied_quantity' => :'source_applied_quantity',
        :'source_applied_quantity_amount' => :'source_applied_quantity_amount',
        :'target_index' => :'target_index',
        :'target_applied_quantity' => :'target_applied_quantity',
        :'target_applied_quantity_amount' => :'target_applied_quantity_amount',
        :'target_applied_discount_amount' => :'target_applied_discount_amount'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'source_index' => :'Integer',
        :'source_applied_quantity' => :'Integer',
        :'source_applied_quantity_amount' => :'Integer',
        :'target_index' => :'Integer',
        :'target_applied_quantity' => :'Integer',
        :'target_applied_quantity_amount' => :'Integer',
        :'target_applied_discount_amount' => :'Integer'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        h[k.to_sym] = v
      }

      if attributes.key?(:'source_index')
        self.source_index = attributes[:'source_index']
      end

      if attributes.key?(:'source_applied_quantity')
        self.source_applied_quantity = attributes[:'source_applied_quantity']
      end

      if attributes.key?(:'source_applied_quantity_amount')
        self.source_applied_quantity_amount = attributes[:'source_applied_quantity_amount']
      end

      if attributes.key?(:'target_index')
        self.target_index = attributes[:'target_index']
      end

      if attributes.key?(:'target_applied_quantity')
        self.target_applied_quantity = attributes[:'target_applied_quantity']
      end

      if attributes.key?(:'target_applied_quantity_amount')
        self.target_applied_quantity_amount = attributes[:'target_applied_quantity_amount']
      end

      if attributes.key?(:'target_applied_discount_amount')
        self.target_applied_discount_amount = attributes[:'target_applied_discount_amount']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if !@source_index.nil? && @source_index < 0
        invalid_properties.push('invalid value for "source_index", must be greater than or equal to 0.')
      end

      if !@source_applied_quantity.nil? && @source_applied_quantity > -1
        invalid_properties.push('invalid value for "source_applied_quantity", must be smaller than or equal to -1.')
      end

      if !@source_applied_quantity_amount.nil? && @source_applied_quantity_amount > 0
        invalid_properties.push('invalid value for "source_applied_quantity_amount", must be smaller than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if !@source_index.nil? && @source_index < 0
      return false if !@source_applied_quantity.nil? && @source_applied_quantity > -1
      return false if !@source_applied_quantity_amount.nil? && @source_applied_quantity_amount > 0
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          source_index == o.source_index &&
          source_applied_quantity == o.source_applied_quantity &&
          source_applied_quantity_amount == o.source_applied_quantity_amount &&
          target_index == o.target_index &&
          target_applied_quantity == o.target_applied_quantity &&
          target_applied_quantity_amount == o.target_applied_quantity_amount &&
          target_applied_discount_amount == o.target_applied_discount_amount
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [source_index, source_applied_quantity, source_applied_quantity_amount, target_index, target_applied_quantity, target_applied_quantity_amount, target_applied_discount_amount].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = VoucherifySdk.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
